/**
 * Copyright &copy; 2015-2020 <a href="http://www.jeeplus.org/">JeePlus</a> All rights reserved.
 */
package com.jeeplus.modules.sg.managementcenter.activiti.web;

import com.google.common.collect.Maps;
import com.jeeplus.common.json.AjaxJson;
import com.jeeplus.common.utils.DateUtils;
import com.jeeplus.common.utils.StringUtils;
import com.jeeplus.core.web.BaseController;
import com.jeeplus.modules.act.service.ActProcessService;
import com.jeeplus.modules.act.service.ActTaskService;
import com.jeeplus.modules.sg.managementcenter.activiti.entity.Construction;
import com.jeeplus.modules.sg.managementcenter.activiti.service.ConstructionService;
import com.jeeplus.modules.sys.utils.UserUtils;
import com.jeeplus.modules.test.activiti.entity.OALeave;
import com.jeeplus.modules.test.activiti.service.OALeaveService;
import org.activiti.engine.ProcessEngine;
import org.activiti.engine.ProcessEngines;
import org.activiti.engine.TaskService;
import org.activiti.engine.impl.RepositoryServiceImpl;
import org.activiti.engine.impl.persistence.entity.ProcessDefinitionEntity;
import org.activiti.engine.impl.pvm.process.ActivityImpl;
import org.activiti.engine.repository.ProcessDefinition;
import org.activiti.engine.task.Task;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

/**
 * 施工交底Controller
 * @author
 * @version 2019-11-08
 */
@Controller
@RequestMapping(value = "${adminPath}/managementcenter/activiti")

public class ConstructionController extends BaseController {

	@Autowired
	private ConstructionService constructionService;
	@Autowired
	private ActProcessService actProcessService;
	@Autowired
	private ActTaskService actTaskService;
	
	@ModelAttribute
	public Construction get(@RequestParam(required=false) String id) {
		Construction entity = null;
		if (StringUtils.isNotBlank(id)){
			entity = constructionService.get(id);
		}
		if (entity == null){
			entity = new Construction();
		}
		return entity;
	}


	

	/**
	 * 查看，增加，编辑请假申请表单页面
	 */
	@RequestMapping(value = "form/{mode}")
	public String form(@PathVariable String mode, Construction construction, Model model) {
/*		String proId = construction.getAct().getProcDefId();
		ProcessEngine processEngine = ProcessEngines.getDefaultProcessEngine();
		TaskService taskService = processEngine.getTaskService();
		//根据assignee(代理人)查询任务
		List<Task> tasks = taskService.createTaskQuery().processDefinitionId(proId).list();*//*taskAssignee(proDefId).list();*//*

		ProcessDefinitionEntity def = (ProcessDefinitionEntity) ((RepositoryServiceImpl)rs).getDeployedProcessDefinition(construction.getAct().getProcDefId());
		List<ActivityImpl> activitiList = def.getActivities(); //rs是指RepositoryService的实例


		int size = tasks.size();
		for (int i = 0; i < size; i++) {
			Task task = tasks.get(i);

		}
		//首次运行的时候这个没有输出，因为第一次运行的时候扫描act_ru_task的表里面是空的，但第一次运行完成之后里面会添加一条记录，之后每次运行里面都会添加一条记录
		for (Task task : tasks) {
			System.out.println("taskId:" + task.getId() +
					",taskName:" + task.getName() +
					",assignee:" + task.getAssignee() +
					",createTime:" + task.getCreateTime() +
					",getTaskLocalVariables:" + task.getTaskLocalVariables());
		}*/
		model.addAttribute("construction", construction);
		if("add".equals(mode) || "edit".equals(mode)){
			return "modules/sg/managementcenter/activiti/constructionForm";
		}else{//audit
			return "modules/sg/managementcenter/activiti/constructionAudit";
		}
	}

	/**
	 * 保存请假申请
	 */
	@ResponseBody
	@RequestMapping(value = "save")
	public AjaxJson save(Construction construction, Model model) throws Exception{
		AjaxJson j = new AjaxJson();
		/**
		 * 后台hibernate-validation插件校验
		 */
		String errMsg = beanValidator(construction);
		if (StringUtils.isNotBlank(errMsg)){
			j.setSuccess(false);
			j.setMsg(errMsg);
			return j;
		}

		/**
		 * 流程审批
		 */
		if (StringUtils.isBlank(construction.getId())){
			//新增或编辑表单保存
			constructionService.save(construction);//保存
			String procDefKey = construction.getAct().getProcDefKey();
			// 启动流程
			ProcessDefinition p = actProcessService.getProcessDefinition(construction.getAct().getProcDefId());
			Map<String, Object> vars = Maps.newHashMap();
			vars.put("processer", UserUtils.get(construction.getTuser().getId()).getLoginName());
			String title = construction.getCurrentUser().getName()+"在"+ DateUtils.getDateTime()+"发起"+p.getName();
			actTaskService.startProcessNew(p.getKey(),  "xm_construction_clarificaiton", construction.getId(), title,vars);
			j.setMsg("发起流程审批成功!");
			j.getBody().put("targetUrl",  "/act/task/process/");
		}else{
			//新增或编辑表单保存
			constructionService.save(construction);//保存
			construction.getAct().setComment(("yes".equals(construction.getAct().getFlag())?"[重新申请] ":"[销毁申请] "));
			// 完成流程任务
			Map<String, Object> vars = Maps.newHashMap();
			vars.put("reapply", "yes".equals(construction.getAct().getFlag())? true : false);
			vars.put("processer", UserUtils.get(construction.getTuser().getId()).getLoginName());
			actTaskService.complete(construction.getAct().getTaskId(), construction.getAct().getProcInsId(), construction.getAct().getComment(), construction.getContent(), vars);
			j.setMsg("提交成功！");
			j.getBody().put("targetUrl",  "/act/task/todo/");
		}

		return j;
	}



}